<template>
  <div>
    <div class="gva-form-box">
      <el-form :model="formData" ref="elFormRef" label-position="right" :rules="rule" label-width="80px">
        <el-form-item label="红包金额:" prop="balance">
          <el-input v-model.number="formData.balance" :clearable="false" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="红包类型:" prop="type">
          <el-input v-model.number="formData.type" :clearable="false" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="红包个数:" prop="num">
          <el-input v-model.number="formData.num" :clearable="false" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="红包开始时间:" prop="start_time">
          <el-date-picker v-model="formData.start_time" type="date" placeholder="选择日期" :clearable="false"></el-date-picker>
        </el-form-item>
        <el-form-item label="红包结束时间:" prop="end_time">
          <el-date-picker v-model="formData.end_time" type="date" placeholder="选择日期" :clearable="false"></el-date-picker>
        </el-form-item>
        <el-form-item label="地址限制:" prop="ip_limit">
          <el-input v-model.number="formData.ip_limit" :clearable="false" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="是否显示:" prop="is_show">
          <el-input v-model.number="formData.is_show" :clearable="false" placeholder="请输入" />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="save">保存</el-button>
          <el-button type="primary" @click="back">返回</el-button>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script>
export default {
  name: 'RedPackage'
}
</script>

<script setup>
import {
  createRedPackage,
  updateRedPackage,
  findRedPackage
} from '@/api/airDropRedPackage'

// 自动获取字典
import { getDictFunc } from '@/utils/format'
import { useRoute, useRouter } from "vue-router"
import { ElMessage } from 'element-plus'
import { ref, reactive } from 'vue'
const route = useRoute()
const router = useRouter()

const type = ref('')
const formData = ref({
            balance: 0,
            type: 0,
            num: 0,
            start_time: new Date(),
            end_time: new Date(),
            ip_limit: 0,
            is_show: 0,
        })
// 验证规则
const rule = reactive({
               balance : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               num : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               start_time : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               end_time : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
               ip_limit : [{
                   required: true,
                   message: '',
                   trigger: ['input','blur'],
               }],
})

const elFormRef = ref()

// 初始化方法
const init = async () => {
 // 建议通过url传参获取目标数据ID 调用 find方法进行查询数据操作 从而决定本页面是create还是update 以下为id作为url参数示例
    if (route.query.id) {
      const res = await findRedPackage({ ID: route.query.id })
      if (res.code === 0) {
        formData.value = res.data.re红包
        type.value = 'update'
      }
    } else {
      type.value = 'create'
    }
}

init()
// 保存按钮
const save = async() => {
      elFormRef.value?.validate( async (valid) => {
         if (!valid) return
            let res
           switch (type.value) {
             case 'create':
               res = await createRedPackage(formData.value)
               break
             case 'update':
               res = await updateRedPackage(formData.value)
               break
             default:
               res = await createRedPackage(formData.value)
               break
           }
           if (res.code === 0) {
             ElMessage({
               type: 'success',
               message: '创建/更改成功'
             })
           }
       })
}

// 返回按钮
const back = () => {
    router.go(-1)
}

</script>

<style>
</style>
